document.getElementById('file').addEventListener('change', function() {
    var file = this.files[0];
    var reader = new FileReader();

    reader.onload = function(e) {
        document.getElementById('uploadedImage').src = e.target.result;
        document.querySelector('.file-upload-form').style.display = 'none';
        document.querySelector('.result').style.display = 'block';
    };

    reader.readAsDataURL(file);
});

let error = document.querySelector('.error');
let eyeDropper;

window.onload = () => {
    if ("EyeDropper" in window) {
        eyeDropper = new EyeDropper();
    } else {
        error.classList.remove("hide");
        error.innerText = "Your browser doesn't support Eyedropper API";
        return false;
    }
};

const pickColor = async () => {
    const color = await eyeDropper
        .open()
        .then((colorValue) => {
            error.classList.add("hide");
            let hexValue = colorValue.sRGBHex;
            let rgbArr = [];
            for (let i = 1; i < hexValue.length; i += 2) {
                rgbArr.push(parseInt(hexValue[i] + hexValue[i + 1], 16));
            }
            let rgbValue = "rgb(" + rgbArr.join(', ') + ")";
            document.getElementById('uploadedImage').style.display = "grid";
            document.getElementById('hexResult').value = hexValue;
            document.getElementById('rgbResult').value = rgbValue;
            document.getElementById('displayColor').style.backgroundColor = hexValue;
        })
        .catch((err) => {
            error.classList.remove("hide");
            //If user presses escape to close the eyedropper
            if (err.toString().includes("AbortError")) {
                error.innerText = "";
            } else {
                error.innerText = err;
            }
        });
};

function copyHexCode() {
    const hexInput = document.getElementById('hexResult');
    hexInput.select();
    hexInput.setSelectionRange(0, 99999); /* For mobile devices */
    document.execCommand('copy');
    alert('Hexadecimal color code copied to clipboard: ' + hexInput.value);
}

function copyRgbCode() {
    const rgbInput = document.getElementById('rgbResult');
    rgbInput.select();
    rgbInput.setSelectionRange(0, 99999); /* For mobile devices */
    document.execCommand('copy');
    alert('RGB color code copied to clipboard: ' + rgbInput.value);
}
